/* xnoise-icon-repo.c generated by valac, the Vala compiler
 * generated from xnoise-icon-repo.vala, do not modify */

/* xnoise-icon-repo.vala
 *
 * Copyright (C) 2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens <shuerhaaken@googlemail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define XNOISE_TYPE_ICON_REPO (xnoise_icon_repo_get_type ())
#define XNOISE_ICON_REPO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_ICON_REPO, XnoiseIconRepo))
#define XNOISE_ICON_REPO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_ICON_REPO, XnoiseIconRepoClass))
#define XNOISE_IS_ICON_REPO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_ICON_REPO))
#define XNOISE_IS_ICON_REPO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_ICON_REPO))
#define XNOISE_ICON_REPO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_ICON_REPO, XnoiseIconRepoClass))

typedef struct _XnoiseIconRepo XnoiseIconRepo;
typedef struct _XnoiseIconRepoClass XnoiseIconRepoClass;
typedef struct _XnoiseIconRepoPrivate XnoiseIconRepoPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _XnoiseIconRepo {
	GObject parent_instance;
	XnoiseIconRepoPrivate * priv;
	GdkPixbuf* _title_pix;
};

struct _XnoiseIconRepoClass {
	GObjectClass parent_class;
};

struct _XnoiseIconRepoPrivate {
	GtkIconTheme* theme;
	GdkPixbuf* _artist_icon;
	GdkPixbuf* _genre_icon;
	GdkPixbuf* _folder_symbolic_icon;
	GdkPixbuf* _album_icon;
	GdkPixbuf* _title_icon;
	GdkPixbuf* _video_icon;
	GdkPixbuf* _videos_icon;
	GdkPixbuf* _radios_icon;
	GdkPixbuf* _loading_icon;
	GdkPixbuf* _playlist_icon;
	GdkPixbuf* _local_collection_icon;
	GdkPixbuf* _selected_collection_icon;
	GdkPixbuf* _symbolic_play_icon;
	GdkPixbuf* _symbolic_pause_icon;
	GdkPixbuf* _network_symbolic_icon;
	GdkPixbuf* _radios_icon_menu;
	GdkPixbuf* _album_art_default_icon;
	GdkPixbuf* _various_artists_icon;
};


static gpointer xnoise_icon_repo_parent_class = NULL;

GType xnoise_icon_repo_get_type (void) G_GNUC_CONST;
#define XNOISE_ICON_REPO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_ICON_REPO, XnoiseIconRepoPrivate))
enum  {
	XNOISE_ICON_REPO_DUMMY_PROPERTY,
	XNOISE_ICON_REPO_ARTIST_ICON,
	XNOISE_ICON_REPO_GENRE_ICON,
	XNOISE_ICON_REPO_FOLDER_SYMBOLIC_ICON,
	XNOISE_ICON_REPO_ALBUM_ICON,
	XNOISE_ICON_REPO_TITLE_ICON,
	XNOISE_ICON_REPO_VIDEO_ICON,
	XNOISE_ICON_REPO_VIDEOS_ICON,
	XNOISE_ICON_REPO_RADIOS_ICON,
	XNOISE_ICON_REPO_LOADING_ICON,
	XNOISE_ICON_REPO_PLAYLIST_ICON,
	XNOISE_ICON_REPO_LOCAL_COLLECTION_ICON,
	XNOISE_ICON_REPO_SELECTED_COLLECTION_ICON,
	XNOISE_ICON_REPO_SYMBOLIC_PLAY_ICON,
	XNOISE_ICON_REPO_SYMBOLIC_PAUSE_ICON,
	XNOISE_ICON_REPO_NETWORK_SYMBOLIC_ICON,
	XNOISE_ICON_REPO_RADIOS_ICON_MENU,
	XNOISE_ICON_REPO_ALBUM_ART_DEFAULT_ICON,
	XNOISE_ICON_REPO_VARIOUS_ARTISTS_ICON
};
static void xnoise_icon_repo_update_pixbufs (XnoiseIconRepo* self);
static void xnoise_icon_repo_set_pixbufs (XnoiseIconRepo* self);
static void xnoise_icon_repo_set_video_icon (XnoiseIconRepo* self, GdkPixbuf* value);
GdkPixbuf* xnoise_icon_repo_get_video_icon (XnoiseIconRepo* self);
static void xnoise_icon_repo_set_radios_icon_menu (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_radios_icon (XnoiseIconRepo* self, GdkPixbuf* value);
GdkPixbuf* xnoise_icon_repo_get_radios_icon_menu (XnoiseIconRepo* self);
static void xnoise_icon_repo_set_artist_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_genre_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_album_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_title_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_videos_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_playlist_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_loading_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_local_collection_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_selected_collection_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_symbolic_play_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_symbolic_pause_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_folder_symbolic_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_network_symbolic_icon (XnoiseIconRepo* self, GdkPixbuf* value);
#define XNOISE_ALBUM_IMAGE_SIZE 44
static void xnoise_icon_repo_set_album_art_default_icon (XnoiseIconRepo* self, GdkPixbuf* value);
static void xnoise_icon_repo_set_various_artists_icon (XnoiseIconRepo* self, GdkPixbuf* value);
GtkImage* xnoise_icon_repo_get_themed_image_icon (const gchar* name, GtkIconSize size, gint pixelsize);
GdkPixbuf* xnoise_icon_repo_get_themed_pixbuf_icon (const gchar* name, gint pixel_size, GtkStyleContext* style_context);
XnoiseIconRepo* xnoise_icon_repo_new (void);
XnoiseIconRepo* xnoise_icon_repo_construct (GType object_type);
GdkPixbuf* xnoise_icon_repo_get_artist_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_genre_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_folder_symbolic_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_album_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_title_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_videos_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_radios_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_loading_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_playlist_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_local_collection_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_selected_collection_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_symbolic_play_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_symbolic_pause_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_network_symbolic_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_album_art_default_icon (XnoiseIconRepo* self);
GdkPixbuf* xnoise_icon_repo_get_various_artists_icon (XnoiseIconRepo* self);
static GObject * xnoise_icon_repo_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _xnoise_icon_repo_update_pixbufs_gtk_icon_theme_changed (GtkIconTheme* _sender, gpointer self);
static void xnoise_icon_repo_finalize (GObject* obj);
static void _vala_xnoise_icon_repo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_xnoise_icon_repo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void xnoise_icon_repo_update_pixbufs (XnoiseIconRepo* self) {
	GtkIconTheme* _tmp0_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	g_print ("update_pixbufs\n");
	_tmp0_ = gtk_icon_theme_get_default ();
	self->priv->theme = _tmp0_;
	xnoise_icon_repo_set_pixbufs (self);
	g_signal_emit_by_name (self, "icon-theme-changed");
}


static void xnoise_icon_repo_set_pixbufs (XnoiseIconRepo* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	{
		GtkInvisible* w = NULL;
		GtkInvisible* _tmp0_ = NULL;
		GtkInvisible* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_ = NULL;
		gint iconheight = 0;
		GdkPixbuf* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		GtkInvisible* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		GtkIconTheme* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		GtkIconTheme* _tmp24_ = NULL;
		gboolean _tmp25_ = FALSE;
		GtkInvisible* _tmp33_ = NULL;
		GdkPixbuf* _tmp34_ = NULL;
		GtkIconTheme* _tmp35_ = NULL;
		gboolean _tmp36_ = FALSE;
		GtkIconTheme* _tmp51_ = NULL;
		gboolean _tmp52_ = FALSE;
		GtkIconTheme* _tmp60_ = NULL;
		gboolean _tmp61_ = FALSE;
		GtkInvisible* _tmp69_ = NULL;
		GdkPixbuf* _tmp70_ = NULL;
		GtkIconTheme* _tmp71_ = NULL;
		gboolean _tmp72_ = FALSE;
		GtkIconTheme* _tmp80_ = NULL;
		gboolean _tmp81_ = FALSE;
		GtkIconTheme* _tmp89_ = NULL;
		gboolean _tmp90_ = FALSE;
		GtkIconTheme* _tmp98_ = NULL;
		gboolean _tmp99_ = FALSE;
		GtkIconTheme* _tmp107_ = NULL;
		gboolean _tmp108_ = FALSE;
		GtkIconTheme* _tmp116_ = NULL;
		gboolean _tmp117_ = FALSE;
		GtkIconTheme* _tmp125_ = NULL;
		gboolean _tmp126_ = FALSE;
		GtkIconTheme* _tmp131_ = NULL;
		gboolean _tmp132_ = FALSE;
		_tmp0_ = (GtkInvisible*) gtk_invisible_new ();
		g_object_ref_sink (_tmp0_);
		w = _tmp0_;
		_tmp1_ = w;
		_tmp2_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_FILE, GTK_ICON_SIZE_BUTTON);
		xnoise_icon_repo_set_video_icon (self, _tmp2_);
		_tmp3_ = self->priv->_video_icon;
		_tmp4_ = gdk_pixbuf_get_height (_tmp3_);
		_tmp5_ = _tmp4_;
		iconheight = _tmp5_;
		_tmp6_ = w;
		_tmp7_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_CONNECT, GTK_ICON_SIZE_MENU);
		xnoise_icon_repo_set_radios_icon_menu (self, _tmp7_);
		_tmp8_ = self->priv->theme;
		_tmp9_ = gtk_icon_theme_has_icon (_tmp8_, "xn-stream");
		if (_tmp9_) {
			GdkPixbuf* _tmp10_ = NULL;
			GtkIconTheme* _tmp11_ = NULL;
			gint _tmp12_ = 0;
			GdkPixbuf* _tmp13_ = NULL;
			GdkPixbuf* _tmp14_ = NULL;
			GdkPixbuf* _tmp15_ = NULL;
			GtkIconTheme* _tmp16_ = NULL;
			GdkPixbuf* _tmp17_ = NULL;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			GdkPixbuf* _tmp20_ = NULL;
			GdkPixbuf* _tmp21_ = NULL;
			_tmp11_ = self->priv->theme;
			_tmp12_ = iconheight;
			_tmp13_ = gtk_icon_theme_load_icon (_tmp11_, "xn-stream", _tmp12_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp10_ = _tmp13_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp14_ = _tmp10_;
			xnoise_icon_repo_set_radios_icon (self, _tmp14_);
			_g_object_unref0 (_tmp14_);
			_tmp16_ = self->priv->theme;
			_tmp17_ = self->priv->_radios_icon_menu;
			_tmp18_ = gdk_pixbuf_get_height (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = gtk_icon_theme_load_icon (_tmp16_, "xn-stream", _tmp19_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp15_ = _tmp20_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp21_ = _tmp15_;
			xnoise_icon_repo_set_radios_icon_menu (self, _tmp21_);
			_g_object_unref0 (_tmp21_);
		} else {
			GtkInvisible* _tmp22_ = NULL;
			GdkPixbuf* _tmp23_ = NULL;
			_tmp22_ = w;
			_tmp23_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_CONNECT, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_radios_icon (self, _tmp23_);
		}
		_tmp24_ = self->priv->theme;
		_tmp25_ = gtk_icon_theme_has_icon (_tmp24_, "stock_person");
		if (_tmp25_) {
			GdkPixbuf* _tmp26_ = NULL;
			GtkIconTheme* _tmp27_ = NULL;
			gint _tmp28_ = 0;
			GdkPixbuf* _tmp29_ = NULL;
			GdkPixbuf* _tmp30_ = NULL;
			_tmp27_ = self->priv->theme;
			_tmp28_ = iconheight;
			_tmp29_ = gtk_icon_theme_load_icon (_tmp27_, "stock_person", _tmp28_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp26_ = _tmp29_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp30_ = _tmp26_;
			xnoise_icon_repo_set_artist_icon (self, _tmp30_);
			_g_object_unref0 (_tmp30_);
		} else {
			GtkInvisible* _tmp31_ = NULL;
			GdkPixbuf* _tmp32_ = NULL;
			_tmp31_ = w;
			_tmp32_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_ORIENTATION_PORTRAIT, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_artist_icon (self, _tmp32_);
		}
		_tmp33_ = w;
		_tmp34_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_COPY, GTK_ICON_SIZE_BUTTON);
		xnoise_icon_repo_set_genre_icon (self, _tmp34_);
		xnoise_icon_repo_set_album_icon (self, NULL);
		_tmp35_ = self->priv->theme;
		_tmp36_ = gtk_icon_theme_has_icon (_tmp35_, "media-audio");
		if (_tmp36_) {
			GdkPixbuf* _tmp37_ = NULL;
			GtkIconTheme* _tmp38_ = NULL;
			gint _tmp39_ = 0;
			GdkPixbuf* _tmp40_ = NULL;
			GdkPixbuf* _tmp41_ = NULL;
			_tmp38_ = self->priv->theme;
			_tmp39_ = iconheight;
			_tmp40_ = gtk_icon_theme_load_icon (_tmp38_, "media-audio", _tmp39_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp37_ = _tmp40_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp41_ = _tmp37_;
			xnoise_icon_repo_set_title_icon (self, _tmp41_);
			_g_object_unref0 (_tmp41_);
		} else {
			GtkIconTheme* _tmp42_ = NULL;
			gboolean _tmp43_ = FALSE;
			_tmp42_ = self->priv->theme;
			_tmp43_ = gtk_icon_theme_has_icon (_tmp42_, "audio-x-generic");
			if (_tmp43_) {
				GdkPixbuf* _tmp44_ = NULL;
				GtkIconTheme* _tmp45_ = NULL;
				gint _tmp46_ = 0;
				GdkPixbuf* _tmp47_ = NULL;
				GdkPixbuf* _tmp48_ = NULL;
				_tmp45_ = self->priv->theme;
				_tmp46_ = iconheight;
				_tmp47_ = gtk_icon_theme_load_icon (_tmp45_, "audio-x-generic", _tmp46_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
				_tmp44_ = _tmp47_;
				if (_inner_error_ != NULL) {
					_g_object_unref0 (w);
					goto __catch75_g_error;
				}
				_tmp48_ = _tmp44_;
				xnoise_icon_repo_set_title_icon (self, _tmp48_);
				_g_object_unref0 (_tmp48_);
			} else {
				GtkInvisible* _tmp49_ = NULL;
				GdkPixbuf* _tmp50_ = NULL;
				_tmp49_ = w;
				_tmp50_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_OPEN, GTK_ICON_SIZE_BUTTON);
				xnoise_icon_repo_set_title_icon (self, _tmp50_);
			}
		}
		_tmp51_ = self->priv->theme;
		_tmp52_ = gtk_icon_theme_has_icon (_tmp51_, "video-x-generic");
		if (_tmp52_) {
			GdkPixbuf* _tmp53_ = NULL;
			GtkIconTheme* _tmp54_ = NULL;
			gint _tmp55_ = 0;
			GdkPixbuf* _tmp56_ = NULL;
			GdkPixbuf* _tmp57_ = NULL;
			_tmp54_ = self->priv->theme;
			_tmp55_ = iconheight;
			_tmp56_ = gtk_icon_theme_load_icon (_tmp54_, "video-x-generic", _tmp55_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp53_ = _tmp56_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp57_ = _tmp53_;
			xnoise_icon_repo_set_videos_icon (self, _tmp57_);
			_g_object_unref0 (_tmp57_);
		} else {
			GtkInvisible* _tmp58_ = NULL;
			GdkPixbuf* _tmp59_ = NULL;
			_tmp58_ = w;
			_tmp59_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_MEDIA_RECORD, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_videos_icon (self, _tmp59_);
		}
		_tmp60_ = self->priv->theme;
		_tmp61_ = gtk_icon_theme_has_icon (_tmp60_, "xn-playlist");
		if (_tmp61_) {
			GdkPixbuf* _tmp62_ = NULL;
			GtkIconTheme* _tmp63_ = NULL;
			gint _tmp64_ = 0;
			GdkPixbuf* _tmp65_ = NULL;
			GdkPixbuf* _tmp66_ = NULL;
			_tmp63_ = self->priv->theme;
			_tmp64_ = iconheight;
			_tmp65_ = gtk_icon_theme_load_icon (_tmp63_, "xn-playlist", _tmp64_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp62_ = _tmp65_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp66_ = _tmp62_;
			xnoise_icon_repo_set_playlist_icon (self, _tmp66_);
			_g_object_unref0 (_tmp66_);
		} else {
			GtkInvisible* _tmp67_ = NULL;
			GdkPixbuf* _tmp68_ = NULL;
			_tmp67_ = w;
			_tmp68_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_YES, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_playlist_icon (self, _tmp68_);
		}
		_tmp69_ = w;
		_tmp70_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_REFRESH, GTK_ICON_SIZE_BUTTON);
		xnoise_icon_repo_set_loading_icon (self, _tmp70_);
		_tmp71_ = self->priv->theme;
		_tmp72_ = gtk_icon_theme_has_icon (_tmp71_, "xn-local-collection");
		if (_tmp72_) {
			GdkPixbuf* _tmp73_ = NULL;
			GtkIconTheme* _tmp74_ = NULL;
			gint _tmp75_ = 0;
			GdkPixbuf* _tmp76_ = NULL;
			GdkPixbuf* _tmp77_ = NULL;
			_tmp74_ = self->priv->theme;
			_tmp75_ = iconheight;
			_tmp76_ = gtk_icon_theme_load_icon (_tmp74_, "xn-local-collection", _tmp75_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp73_ = _tmp76_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp77_ = _tmp73_;
			xnoise_icon_repo_set_local_collection_icon (self, _tmp77_);
			_g_object_unref0 (_tmp77_);
		} else {
			GtkInvisible* _tmp78_ = NULL;
			GdkPixbuf* _tmp79_ = NULL;
			_tmp78_ = w;
			_tmp79_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_HOME, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_local_collection_icon (self, _tmp79_);
		}
		_tmp80_ = self->priv->theme;
		_tmp81_ = gtk_icon_theme_has_icon (_tmp80_, "xn-current-position");
		if (_tmp81_) {
			GdkPixbuf* _tmp82_ = NULL;
			GtkIconTheme* _tmp83_ = NULL;
			gint _tmp84_ = 0;
			GdkPixbuf* _tmp85_ = NULL;
			GdkPixbuf* _tmp86_ = NULL;
			_tmp83_ = self->priv->theme;
			_tmp84_ = iconheight;
			_tmp85_ = gtk_icon_theme_load_icon (_tmp83_, "xn-current-position", _tmp84_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp82_ = _tmp85_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp86_ = _tmp82_;
			xnoise_icon_repo_set_selected_collection_icon (self, _tmp86_);
			_g_object_unref0 (_tmp86_);
		} else {
			GtkInvisible* _tmp87_ = NULL;
			GdkPixbuf* _tmp88_ = NULL;
			_tmp87_ = w;
			_tmp88_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp87_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_YES, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_selected_collection_icon (self, _tmp88_);
		}
		_tmp89_ = self->priv->theme;
		_tmp90_ = gtk_icon_theme_has_icon (_tmp89_, "media-playback-start-symbolic");
		if (_tmp90_) {
			GdkPixbuf* _tmp91_ = NULL;
			GtkIconTheme* _tmp92_ = NULL;
			gint _tmp93_ = 0;
			GdkPixbuf* _tmp94_ = NULL;
			GdkPixbuf* _tmp95_ = NULL;
			_tmp92_ = self->priv->theme;
			_tmp93_ = iconheight;
			_tmp94_ = gtk_icon_theme_load_icon (_tmp92_, "media-playback-start-symbolic", _tmp93_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp91_ = _tmp94_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp95_ = _tmp91_;
			xnoise_icon_repo_set_symbolic_play_icon (self, _tmp95_);
			_g_object_unref0 (_tmp95_);
		} else {
			GtkInvisible* _tmp96_ = NULL;
			GdkPixbuf* _tmp97_ = NULL;
			_tmp96_ = w;
			_tmp97_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_MEDIA_PLAY, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_symbolic_play_icon (self, _tmp97_);
		}
		_tmp98_ = self->priv->theme;
		_tmp99_ = gtk_icon_theme_has_icon (_tmp98_, "media-playback-pause-symbolic");
		if (_tmp99_) {
			GdkPixbuf* _tmp100_ = NULL;
			GtkIconTheme* _tmp101_ = NULL;
			gint _tmp102_ = 0;
			GdkPixbuf* _tmp103_ = NULL;
			GdkPixbuf* _tmp104_ = NULL;
			_tmp101_ = self->priv->theme;
			_tmp102_ = iconheight;
			_tmp103_ = gtk_icon_theme_load_icon (_tmp101_, "media-playback-pause-symbolic", _tmp102_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp100_ = _tmp103_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp104_ = _tmp100_;
			xnoise_icon_repo_set_symbolic_pause_icon (self, _tmp104_);
			_g_object_unref0 (_tmp104_);
		} else {
			GtkInvisible* _tmp105_ = NULL;
			GdkPixbuf* _tmp106_ = NULL;
			_tmp105_ = w;
			_tmp106_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_MEDIA_PAUSE, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_symbolic_pause_icon (self, _tmp106_);
		}
		_tmp107_ = self->priv->theme;
		_tmp108_ = gtk_icon_theme_has_icon (_tmp107_, "folder-symbolic");
		if (_tmp108_) {
			GdkPixbuf* _tmp109_ = NULL;
			GtkIconTheme* _tmp110_ = NULL;
			gint _tmp111_ = 0;
			GdkPixbuf* _tmp112_ = NULL;
			GdkPixbuf* _tmp113_ = NULL;
			_tmp110_ = self->priv->theme;
			_tmp111_ = iconheight;
			_tmp112_ = gtk_icon_theme_load_icon (_tmp110_, "folder-symbolic", _tmp111_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp109_ = _tmp112_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp113_ = _tmp109_;
			xnoise_icon_repo_set_folder_symbolic_icon (self, _tmp113_);
			_g_object_unref0 (_tmp113_);
		} else {
			GtkInvisible* _tmp114_ = NULL;
			GdkPixbuf* _tmp115_ = NULL;
			_tmp114_ = w;
			_tmp115_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp114_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_DIRECTORY, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_folder_symbolic_icon (self, _tmp115_);
		}
		_tmp116_ = self->priv->theme;
		_tmp117_ = gtk_icon_theme_has_icon (_tmp116_, "network-transmit-symbolic");
		if (_tmp117_) {
			GdkPixbuf* _tmp118_ = NULL;
			GtkIconTheme* _tmp119_ = NULL;
			gint _tmp120_ = 0;
			GdkPixbuf* _tmp121_ = NULL;
			GdkPixbuf* _tmp122_ = NULL;
			_tmp119_ = self->priv->theme;
			_tmp120_ = iconheight;
			_tmp121_ = gtk_icon_theme_load_icon (_tmp119_, "network-transmit-symbolic", _tmp120_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp118_ = _tmp121_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp122_ = _tmp118_;
			xnoise_icon_repo_set_network_symbolic_icon (self, _tmp122_);
			_g_object_unref0 (_tmp122_);
		} else {
			GtkInvisible* _tmp123_ = NULL;
			GdkPixbuf* _tmp124_ = NULL;
			_tmp123_ = w;
			_tmp124_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_CONNECT, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_network_symbolic_icon (self, _tmp124_);
		}
		_tmp125_ = self->priv->theme;
		_tmp126_ = gtk_icon_theme_has_icon (_tmp125_, "xnoise-no-border");
		if (_tmp126_) {
			GdkPixbuf* _tmp127_ = NULL;
			GtkIconTheme* _tmp128_ = NULL;
			GdkPixbuf* _tmp129_ = NULL;
			GdkPixbuf* _tmp130_ = NULL;
			_tmp128_ = self->priv->theme;
			_tmp129_ = gtk_icon_theme_load_icon (_tmp128_, "xnoise-no-border", XNOISE_ALBUM_IMAGE_SIZE, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
			_tmp127_ = _tmp129_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp130_ = _tmp127_;
			xnoise_icon_repo_set_album_art_default_icon (self, _tmp130_);
			_g_object_unref0 (_tmp130_);
		}
		_tmp131_ = self->priv->theme;
		_tmp132_ = gtk_icon_theme_has_icon (_tmp131_, "system-users");
		if (_tmp132_) {
			GdkPixbuf* _tmp133_ = NULL;
			GtkIconTheme* _tmp134_ = NULL;
			gint _tmp135_ = 0;
			GdkPixbuf* _tmp136_ = NULL;
			GdkPixbuf* _tmp137_ = NULL;
			_tmp134_ = self->priv->theme;
			_tmp135_ = iconheight;
			_tmp136_ = gtk_icon_theme_load_icon (_tmp134_, "system-users", _tmp135_, GTK_ICON_LOOKUP_USE_BUILTIN, &_inner_error_);
			_tmp133_ = _tmp136_;
			if (_inner_error_ != NULL) {
				_g_object_unref0 (w);
				goto __catch75_g_error;
			}
			_tmp137_ = _tmp133_;
			xnoise_icon_repo_set_various_artists_icon (self, _tmp137_);
			_g_object_unref0 (_tmp137_);
		} else {
			GtkInvisible* _tmp138_ = NULL;
			GdkPixbuf* _tmp139_ = NULL;
			_tmp138_ = w;
			_tmp139_ = gtk_widget_render_icon_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp138_, GTK_TYPE_WIDGET, GtkWidget), GTK_STOCK_ORIENTATION_PORTRAIT, GTK_ICON_SIZE_BUTTON);
			xnoise_icon_repo_set_various_artists_icon (self, _tmp139_);
		}
		_g_object_unref0 (w);
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError* e = NULL;
		GError* _tmp140_ = NULL;
		const gchar* _tmp141_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp140_ = e;
		_tmp141_ = _tmp140_->message;
		g_print ("Error: %s\n", _tmp141_);
		_g_error_free0 (e);
	}
	__finally75:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GtkImage* xnoise_icon_repo_get_themed_image_icon (const gchar* name, GtkIconSize size, gint pixelsize) {
	GtkImage* result = NULL;
	GtkImage* image = NULL;
	GIcon* gicon = NULL;
	const gchar* _tmp0_ = NULL;
	GThemedIcon* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp9_ = 0;
	g_return_val_if_fail (name != NULL, NULL);
	image = NULL;
	_tmp0_ = name;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
	gicon = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_ICON, GIcon);
	_tmp2_ = name;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_ = NULL;
		GtkIconSize _tmp4_ = 0;
		GtkImage* _tmp5_ = NULL;
		_tmp3_ = name;
		_tmp4_ = size;
		_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp3_, _tmp4_);
		g_object_ref_sink (_tmp5_);
		_g_object_unref0 (image);
		image = _tmp5_;
	} else {
		GIcon* _tmp6_ = NULL;
		GtkIconSize _tmp7_ = 0;
		GtkImage* _tmp8_ = NULL;
		_tmp6_ = gicon;
		_tmp7_ = size;
		_tmp8_ = (GtkImage*) gtk_image_new_from_gicon (_tmp6_, _tmp7_);
		g_object_ref_sink (_tmp8_);
		_g_object_unref0 (image);
		image = _tmp8_;
	}
	_tmp9_ = pixelsize;
	if (_tmp9_ != (-1)) {
		GtkImage* _tmp10_ = NULL;
		gint _tmp11_ = 0;
		_tmp10_ = image;
		_tmp11_ = pixelsize;
		gtk_image_set_pixel_size (_tmp10_, _tmp11_);
	}
	result = image;
	_g_object_unref0 (gicon);
	return result;
}


GdkPixbuf* xnoise_icon_repo_get_themed_pixbuf_icon (const gchar* name, gint pixel_size, GtkStyleContext* style_context) {
	GdkPixbuf* result = NULL;
	GtkImage* image = NULL;
	GIcon* gicon = NULL;
	const gchar* _tmp0_ = NULL;
	GThemedIcon* _tmp1_ = NULL;
	GIcon* _tmp2_ = NULL;
	gint width = 0;
	gint height = 0;
	GdkPixbuf* pix = NULL;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail ((style_context == NULL) || GTK_IS_STYLE_CONTEXT (style_context), NULL);
	image = NULL;
	_tmp0_ = name;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
	gicon = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_ICON, GIcon);
	_tmp2_ = gicon;
	_vala_assert (_tmp2_ != NULL, "gicon != null");
	pix = NULL;
	_tmp3_ = gtk_icon_theme_get_default ();
	theme = _tmp3_;
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp4_ = NULL;
		GIcon* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		GtkIconInfo* _tmp7_ = NULL;
		GtkIconInfo* _tmp8_ = NULL;
		GdkPixbuf* _tmp17_ = NULL;
		_tmp4_ = theme;
		_tmp5_ = gicon;
		_tmp6_ = pixel_size;
		_tmp7_ = gtk_icon_theme_lookup_by_gicon (_tmp4_, _tmp5_, _tmp6_, GTK_ICON_LOOKUP_USE_BUILTIN);
		icon_info = _tmp7_;
		_tmp8_ = icon_info;
		if (_tmp8_ != NULL) {
			GtkStyleContext* _tmp9_ = NULL;
			_tmp9_ = style_context;
			if (_tmp9_ != NULL) {
				GdkPixbuf* _tmp10_ = NULL;
				GtkIconInfo* _tmp11_ = NULL;
				GtkStyleContext* _tmp12_ = NULL;
				GdkPixbuf* _tmp13_ = NULL;
				_tmp11_ = icon_info;
				_tmp12_ = style_context;
				_tmp13_ = gtk_icon_info_load_symbolic_for_context (_tmp11_, _tmp12_, NULL, &_inner_error_);
				_tmp10_ = _tmp13_;
				if (_inner_error_ != NULL) {
					_gtk_icon_info_free0 (icon_info);
					goto __catch76_g_error;
				}
				_g_object_unref0 (pix);
				pix = _tmp10_;
			} else {
				GdkPixbuf* _tmp14_ = NULL;
				GtkIconInfo* _tmp15_ = NULL;
				GdkPixbuf* _tmp16_ = NULL;
				_tmp15_ = icon_info;
				_tmp16_ = gtk_icon_info_load_icon (_tmp15_, &_inner_error_);
				_tmp14_ = _tmp16_;
				if (_inner_error_ != NULL) {
					_gtk_icon_info_free0 (icon_info);
					goto __catch76_g_error;
				}
				_g_object_unref0 (pix);
				pix = _tmp14_;
			}
		}
		_tmp17_ = pix;
		if (_tmp17_ == NULL) {
			GdkPixbuf* _tmp18_ = NULL;
			GtkIconTheme* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			GdkPixbuf* _tmp21_ = NULL;
			_tmp19_ = theme;
			_tmp20_ = pixel_size;
			_tmp21_ = gtk_icon_theme_load_icon (_tmp19_, GTK_STOCK_MISSING_IMAGE, _tmp20_, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error_);
			_tmp18_ = _tmp21_;
			if (_inner_error_ != NULL) {
				_gtk_icon_info_free0 (icon_info);
				goto __catch76_g_error;
			}
			_g_object_unref0 (pix);
			pix = _tmp18_;
		}
		_gtk_icon_info_free0 (icon_info);
	}
	goto __finally76;
	__catch76_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		GdkPixbuf* _tmp24_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		g_print ("%s", _tmp23_);
		_tmp24_ = pix;
		if (_tmp24_ == NULL) {
			GdkPixbuf* _tmp25_ = NULL;
			GtkIconTheme* _tmp26_ = NULL;
			gint _tmp27_ = 0;
			GdkPixbuf* _tmp28_ = NULL;
			_tmp26_ = theme;
			_tmp27_ = pixel_size;
			_tmp28_ = gtk_icon_theme_load_icon (_tmp26_, GTK_STOCK_MISSING_IMAGE, _tmp27_, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error_);
			_tmp25_ = _tmp28_;
			if (_inner_error_ != NULL) {
				_g_error_free0 (e);
				goto __finally76;
			}
			_g_object_unref0 (pix);
			pix = _tmp25_;
		}
		_g_error_free0 (e);
	}
	__finally76:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (pix);
		_g_object_unref0 (gicon);
		_g_object_unref0 (image);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = pix;
	_g_object_unref0 (gicon);
	_g_object_unref0 (image);
	return result;
}


XnoiseIconRepo* xnoise_icon_repo_construct (GType object_type) {
	XnoiseIconRepo * self = NULL;
	self = (XnoiseIconRepo*) g_object_new (object_type, NULL);
	return self;
}


XnoiseIconRepo* xnoise_icon_repo_new (void) {
	return xnoise_icon_repo_construct (XNOISE_TYPE_ICON_REPO);
}


GdkPixbuf* xnoise_icon_repo_get_artist_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_artist_icon;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_icon_repo_set_artist_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_artist_icon);
	self->priv->_artist_icon = _tmp1_;
	g_object_notify ((GObject *) self, "artist-icon");
}


GdkPixbuf* xnoise_icon_repo_get_genre_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_genre_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_genre_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_genre_icon);
	self->priv->_genre_icon = _tmp1_;
	g_object_notify ((GObject *) self, "genre-icon");
}


GdkPixbuf* xnoise_icon_repo_get_folder_symbolic_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_folder_symbolic_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_folder_symbolic_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_folder_symbolic_icon);
	self->priv->_folder_symbolic_icon = _tmp1_;
	g_object_notify ((GObject *) self, "folder-symbolic-icon");
}


GdkPixbuf* xnoise_icon_repo_get_album_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_album_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_album_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_album_icon);
	self->priv->_album_icon = _tmp1_;
	g_object_notify ((GObject *) self, "album-icon");
}


GdkPixbuf* xnoise_icon_repo_get_title_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_title_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_title_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_title_icon);
	self->priv->_title_icon = _tmp1_;
	g_object_notify ((GObject *) self, "title-icon");
}


GdkPixbuf* xnoise_icon_repo_get_video_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_video_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_video_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_video_icon);
	self->priv->_video_icon = _tmp1_;
	g_object_notify ((GObject *) self, "video-icon");
}


GdkPixbuf* xnoise_icon_repo_get_videos_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_videos_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_videos_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_videos_icon);
	self->priv->_videos_icon = _tmp1_;
	g_object_notify ((GObject *) self, "videos-icon");
}


GdkPixbuf* xnoise_icon_repo_get_radios_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_radios_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_radios_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_radios_icon);
	self->priv->_radios_icon = _tmp1_;
	g_object_notify ((GObject *) self, "radios-icon");
}


GdkPixbuf* xnoise_icon_repo_get_loading_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_loading_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_loading_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_loading_icon);
	self->priv->_loading_icon = _tmp1_;
	g_object_notify ((GObject *) self, "loading-icon");
}


GdkPixbuf* xnoise_icon_repo_get_playlist_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_playlist_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_playlist_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_playlist_icon);
	self->priv->_playlist_icon = _tmp1_;
	g_object_notify ((GObject *) self, "playlist-icon");
}


GdkPixbuf* xnoise_icon_repo_get_local_collection_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_local_collection_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_local_collection_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_local_collection_icon);
	self->priv->_local_collection_icon = _tmp1_;
	g_object_notify ((GObject *) self, "local-collection-icon");
}


GdkPixbuf* xnoise_icon_repo_get_selected_collection_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_selected_collection_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_selected_collection_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_selected_collection_icon);
	self->priv->_selected_collection_icon = _tmp1_;
	g_object_notify ((GObject *) self, "selected-collection-icon");
}


GdkPixbuf* xnoise_icon_repo_get_symbolic_play_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_symbolic_play_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_symbolic_play_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_symbolic_play_icon);
	self->priv->_symbolic_play_icon = _tmp1_;
	g_object_notify ((GObject *) self, "symbolic-play-icon");
}


GdkPixbuf* xnoise_icon_repo_get_symbolic_pause_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_symbolic_pause_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_symbolic_pause_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_symbolic_pause_icon);
	self->priv->_symbolic_pause_icon = _tmp1_;
	g_object_notify ((GObject *) self, "symbolic-pause-icon");
}


GdkPixbuf* xnoise_icon_repo_get_network_symbolic_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_network_symbolic_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_network_symbolic_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_network_symbolic_icon);
	self->priv->_network_symbolic_icon = _tmp1_;
	g_object_notify ((GObject *) self, "network-symbolic-icon");
}


GdkPixbuf* xnoise_icon_repo_get_radios_icon_menu (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_radios_icon_menu;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_radios_icon_menu (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_radios_icon_menu);
	self->priv->_radios_icon_menu = _tmp1_;
	g_object_notify ((GObject *) self, "radios-icon-menu");
}


GdkPixbuf* xnoise_icon_repo_get_album_art_default_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_album_art_default_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_album_art_default_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_album_art_default_icon);
	self->priv->_album_art_default_icon = _tmp1_;
	g_object_notify ((GObject *) self, "album-art-default-icon");
}


GdkPixbuf* xnoise_icon_repo_get_various_artists_icon (XnoiseIconRepo* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
	g_return_val_if_fail (XNOISE_IS_ICON_REPO (self), NULL);
	_tmp0_ = self->priv->_various_artists_icon;
	result = _tmp0_;
	return result;
}


static void xnoise_icon_repo_set_various_artists_icon (XnoiseIconRepo* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	g_return_if_fail (XNOISE_IS_ICON_REPO (self));
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_various_artists_icon);
	self->priv->_various_artists_icon = _tmp1_;
	g_object_notify ((GObject *) self, "various-artists-icon");
}


static void _xnoise_icon_repo_update_pixbufs_gtk_icon_theme_changed (GtkIconTheme* _sender, gpointer self) {
	xnoise_icon_repo_update_pixbufs (self);
}


static GObject * xnoise_icon_repo_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	XnoiseIconRepo * self;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* _tmp1_ = NULL;
	parent_class = G_OBJECT_CLASS (xnoise_icon_repo_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_ICON_REPO, XnoiseIconRepo);
	_tmp0_ = gtk_icon_theme_get_default ();
	self->priv->theme = _tmp0_;
	_tmp1_ = self->priv->theme;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _xnoise_icon_repo_update_pixbufs_gtk_icon_theme_changed, self, 0);
	xnoise_icon_repo_set_pixbufs (self);
	return obj;
}


static void xnoise_icon_repo_class_init (XnoiseIconRepoClass * klass) {
	xnoise_icon_repo_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseIconRepoPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_xnoise_icon_repo_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_xnoise_icon_repo_set_property;
	G_OBJECT_CLASS (klass)->constructor = xnoise_icon_repo_constructor;
	G_OBJECT_CLASS (klass)->finalize = xnoise_icon_repo_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_ARTIST_ICON, g_param_spec_object ("artist-icon", "artist-icon", "artist-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_GENRE_ICON, g_param_spec_object ("genre-icon", "genre-icon", "genre-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_FOLDER_SYMBOLIC_ICON, g_param_spec_object ("folder-symbolic-icon", "folder-symbolic-icon", "folder-symbolic-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_ALBUM_ICON, g_param_spec_object ("album-icon", "album-icon", "album-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_TITLE_ICON, g_param_spec_object ("title-icon", "title-icon", "title-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_VIDEO_ICON, g_param_spec_object ("video-icon", "video-icon", "video-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_VIDEOS_ICON, g_param_spec_object ("videos-icon", "videos-icon", "videos-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_RADIOS_ICON, g_param_spec_object ("radios-icon", "radios-icon", "radios-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_LOADING_ICON, g_param_spec_object ("loading-icon", "loading-icon", "loading-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_PLAYLIST_ICON, g_param_spec_object ("playlist-icon", "playlist-icon", "playlist-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_LOCAL_COLLECTION_ICON, g_param_spec_object ("local-collection-icon", "local-collection-icon", "local-collection-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_SELECTED_COLLECTION_ICON, g_param_spec_object ("selected-collection-icon", "selected-collection-icon", "selected-collection-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_SYMBOLIC_PLAY_ICON, g_param_spec_object ("symbolic-play-icon", "symbolic-play-icon", "symbolic-play-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_SYMBOLIC_PAUSE_ICON, g_param_spec_object ("symbolic-pause-icon", "symbolic-pause-icon", "symbolic-pause-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_NETWORK_SYMBOLIC_ICON, g_param_spec_object ("network-symbolic-icon", "network-symbolic-icon", "network-symbolic-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_RADIOS_ICON_MENU, g_param_spec_object ("radios-icon-menu", "radios-icon-menu", "radios-icon-menu", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_ALBUM_ART_DEFAULT_ICON, g_param_spec_object ("album-art-default-icon", "album-art-default-icon", "album-art-default-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_ICON_REPO_VARIOUS_ARTISTS_ICON, g_param_spec_object ("various-artists-icon", "various-artists-icon", "various-artists-icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("icon_theme_changed", XNOISE_TYPE_ICON_REPO, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void xnoise_icon_repo_instance_init (XnoiseIconRepo * self) {
	self->priv = XNOISE_ICON_REPO_GET_PRIVATE (self);
	self->priv->theme = NULL;
}


static void xnoise_icon_repo_finalize (GObject* obj) {
	XnoiseIconRepo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_ICON_REPO, XnoiseIconRepo);
	_g_object_unref0 (self->priv->_artist_icon);
	_g_object_unref0 (self->priv->_genre_icon);
	_g_object_unref0 (self->priv->_folder_symbolic_icon);
	_g_object_unref0 (self->priv->_album_icon);
	_g_object_unref0 (self->priv->_title_icon);
	_g_object_unref0 (self->priv->_video_icon);
	_g_object_unref0 (self->priv->_videos_icon);
	_g_object_unref0 (self->priv->_radios_icon);
	_g_object_unref0 (self->priv->_loading_icon);
	_g_object_unref0 (self->priv->_playlist_icon);
	_g_object_unref0 (self->priv->_local_collection_icon);
	_g_object_unref0 (self->priv->_selected_collection_icon);
	_g_object_unref0 (self->priv->_symbolic_play_icon);
	_g_object_unref0 (self->priv->_symbolic_pause_icon);
	_g_object_unref0 (self->priv->_network_symbolic_icon);
	_g_object_unref0 (self->priv->_radios_icon_menu);
	_g_object_unref0 (self->priv->_album_art_default_icon);
	_g_object_unref0 (self->priv->_various_artists_icon);
	_g_object_unref0 (self->_title_pix);
	G_OBJECT_CLASS (xnoise_icon_repo_parent_class)->finalize (obj);
}


GType xnoise_icon_repo_get_type (void) {
	static volatile gsize xnoise_icon_repo_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_icon_repo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseIconRepoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_icon_repo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseIconRepo), 0, (GInstanceInitFunc) xnoise_icon_repo_instance_init, NULL };
		GType xnoise_icon_repo_type_id;
		xnoise_icon_repo_type_id = g_type_register_static (G_TYPE_OBJECT, "XnoiseIconRepo", &g_define_type_info, 0);
		g_once_init_leave (&xnoise_icon_repo_type_id__volatile, xnoise_icon_repo_type_id);
	}
	return xnoise_icon_repo_type_id__volatile;
}


static void _vala_xnoise_icon_repo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseIconRepo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_ICON_REPO, XnoiseIconRepo);
	switch (property_id) {
		case XNOISE_ICON_REPO_ARTIST_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_artist_icon (self));
		break;
		case XNOISE_ICON_REPO_GENRE_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_genre_icon (self));
		break;
		case XNOISE_ICON_REPO_FOLDER_SYMBOLIC_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_folder_symbolic_icon (self));
		break;
		case XNOISE_ICON_REPO_ALBUM_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_album_icon (self));
		break;
		case XNOISE_ICON_REPO_TITLE_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_title_icon (self));
		break;
		case XNOISE_ICON_REPO_VIDEO_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_video_icon (self));
		break;
		case XNOISE_ICON_REPO_VIDEOS_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_videos_icon (self));
		break;
		case XNOISE_ICON_REPO_RADIOS_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_radios_icon (self));
		break;
		case XNOISE_ICON_REPO_LOADING_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_loading_icon (self));
		break;
		case XNOISE_ICON_REPO_PLAYLIST_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_playlist_icon (self));
		break;
		case XNOISE_ICON_REPO_LOCAL_COLLECTION_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_local_collection_icon (self));
		break;
		case XNOISE_ICON_REPO_SELECTED_COLLECTION_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_selected_collection_icon (self));
		break;
		case XNOISE_ICON_REPO_SYMBOLIC_PLAY_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_symbolic_play_icon (self));
		break;
		case XNOISE_ICON_REPO_SYMBOLIC_PAUSE_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_symbolic_pause_icon (self));
		break;
		case XNOISE_ICON_REPO_NETWORK_SYMBOLIC_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_network_symbolic_icon (self));
		break;
		case XNOISE_ICON_REPO_RADIOS_ICON_MENU:
		g_value_set_object (value, xnoise_icon_repo_get_radios_icon_menu (self));
		break;
		case XNOISE_ICON_REPO_ALBUM_ART_DEFAULT_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_album_art_default_icon (self));
		break;
		case XNOISE_ICON_REPO_VARIOUS_ARTISTS_ICON:
		g_value_set_object (value, xnoise_icon_repo_get_various_artists_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_xnoise_icon_repo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseIconRepo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_ICON_REPO, XnoiseIconRepo);
	switch (property_id) {
		case XNOISE_ICON_REPO_ARTIST_ICON:
		xnoise_icon_repo_set_artist_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_GENRE_ICON:
		xnoise_icon_repo_set_genre_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_FOLDER_SYMBOLIC_ICON:
		xnoise_icon_repo_set_folder_symbolic_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_ALBUM_ICON:
		xnoise_icon_repo_set_album_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_TITLE_ICON:
		xnoise_icon_repo_set_title_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_VIDEO_ICON:
		xnoise_icon_repo_set_video_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_VIDEOS_ICON:
		xnoise_icon_repo_set_videos_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_RADIOS_ICON:
		xnoise_icon_repo_set_radios_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_LOADING_ICON:
		xnoise_icon_repo_set_loading_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_PLAYLIST_ICON:
		xnoise_icon_repo_set_playlist_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_LOCAL_COLLECTION_ICON:
		xnoise_icon_repo_set_local_collection_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_SELECTED_COLLECTION_ICON:
		xnoise_icon_repo_set_selected_collection_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_SYMBOLIC_PLAY_ICON:
		xnoise_icon_repo_set_symbolic_play_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_SYMBOLIC_PAUSE_ICON:
		xnoise_icon_repo_set_symbolic_pause_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_NETWORK_SYMBOLIC_ICON:
		xnoise_icon_repo_set_network_symbolic_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_RADIOS_ICON_MENU:
		xnoise_icon_repo_set_radios_icon_menu (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_ALBUM_ART_DEFAULT_ICON:
		xnoise_icon_repo_set_album_art_default_icon (self, g_value_get_object (value));
		break;
		case XNOISE_ICON_REPO_VARIOUS_ARTISTS_ICON:
		xnoise_icon_repo_set_various_artists_icon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



